% Przyklad 10.1:
% m-plik: przyklad_10_1.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 10: Sterowanie dynamika sygnalu.
% Autorzy rozdzialu: Roman Rumian, Wojciech Polchlopek.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2014 r.

clc; clear; close all;

fpr=48000;                      % czestotliwosc probkowania, w [Hz];
dt=1/fpr;                       % odstep miedzy kolejnymi probkami na osi czasu;
N=2^12;                         % liczba probek;
n=0:N-1;                        % numery probek sygnalu;

fo=1000;                        % czestotliwosc sygnalu, w [Hz];
fa=fo/100;                      % czestotliwosc modulacji amplitudy, w [Hz];
ax=abs(cos(2*pi*n*fa/fpr));     % zmienna w czasie amplituda sygnalu;
x0=sin(2*pi*n*fo/fpr);          % sygnal o stalej amplitudzie;
x=x0.*ax;                       % generowanie sygnalu wejsciowego;

AT=0.4;                         % wspolczynnik wagowy "ataku", w [s];
RT=0.001;                       % wspolczynnik wagowy opadania, w [s];
ta=-2.2*dt/log(1-AT),           % stala czasowa ataku wyliczona ze wspolczynnika AT, w [s];
tr=-2.2*dt/log(1-RT),           % stala czasowa opadania wyliczona ze wspolczynnika RT, w [s];  

xPEAK(1)=0;
for n=2:N;
    ax=abs(x(n));
    dx=ax-xPEAK(n-1);
    if dx>0,
        xPEAK(n)=(1-AT)*xPEAK(n-1)+AT*ax;  % wyliczenie probki obwiedni z uzyciem "wagi ataku";
    else
        xPEAK(n)=(1-RT)*xPEAK(n-1);        % wyliczenie probki obwiedni z uzyciem "wagi opadania";
    end;    
end;

y=x0.*xPEAK;                    % weryfikacja efektu;

t=0:dt:(N-1)*dt;                % punkty na osi czasu, wyrazone w [s];

    figure(1);
        plot(t,x,'b.-');  grid on; hold on;
        plot(t,xPEAK,'k.-');
        plot(t,y,'r.-');
            title('Efekt dzialania algorytmu AGC z wykorzystaniem wartosci szczytowej');
            legend('sygnal wejsciowy','obwiednia','sygnal odtworzony z obwiedni',4);
            xlabel('t [s]');
            xlim([t(1),t(end)]);
            
% KONIEC PRZYKLADU 10.1.