% Przyklad 10.2:
% m-plik: przyklad_10_2.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 10: Sterowanie dynamika sygnalu.
% Autorzy rozdzialu: Roman Rumian, Wojciech Polchlopek.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2014 r.

clc; clear; close all;

fpr=48000;                      % czestotliwosc probkowania, w [Hz];
dt=1/fpr;                       % odstep miedzy kolejnymi probkami na osi czasu;
N=2^12;                         % liczba probek;
n=0:N-1;                        % numery probek sygnalu;

fo=1000;                        % czestotliwosc sygnalu, w [Hz];
fa=fo/100;                      % czestotliwosc modulacji amplitudy, w [Hz];
ax=abs(cos(2*pi*n*fa/fpr));     % zmienna w czasie amplituda sygnalu;
x0=sin(2*pi*n*fo/fpr);          % sygnal o stalej amplitudzie;
x=x0.*ax;                       % generowanie sygnalu wejsciowego;

TAV=0.005;                      % wspolczynnik wagowy "ataku", w [s];
tav=-2.2*dt/log(1-TAV),         % stala czasowa ataku wyliczona ze wspolczynnika AT, w [s];

xRMS2(1)=0;
for n=2:N;
    x2=x(n)^2;
    xRMS2(n)=(1-TAV)*xRMS2(n-1)+TAV*x2;  % wyliczenie probki obwiedni z uzyciem "wagi ataku";
end;
xRMS=sqrt(xRMS2);
y=x0.*xRMS;                     % weryfikacja efektu;

t=0:dt:(N-1)*dt;                % punkty na osi czasu, wyrazone w [s];

    figure(1);
        plot(t,x,'b.-');  grid on; hold on;
        plot(t,xRMS,'k.-');
        plot(t,y,'r.-');
            title('Efekt dzialania algorytmu AGC z wykorzystaniem wartosci RMS');
            legend('sygnal wejsciowy','obwiednia RMS','sygnal odtworzony z obwiedni',4);
            xlabel('t [s]');
            xlim([t(1),t(end)]);
            
% KONIEC PRZYKLADU 10.2.